.SUFFIXES: .asm

# defines
MAKEFILE=Makefile
MAKEDEP=$(MAKEFILE)
NASM	=nasm -f elf
GLIBC   =../../libc
LSCRIPT	=./link.ld
LFLAGS	=-g -T$(LSCRIPT)
INCDIR	=$(GLIBC)/include
CC	=gcc -m32 -g -O2 -Wall -W -c -nostdinc -fno-builtin -fno-stack-protector -I$(INCDIR)
#-Wall -W
LD	=ld -m elf_i386 -s -nostdlib
LIBC    =$(GLIBC)/libc.a
OBJS	=start.o main.o net.o proto.o commands.o

# targets
all: irc

linux:
	gcc -oirc_linux main.c net.c proto.c commands.c -DLINUX

install: irc
	mkdir mnt
	mount /dev/fd0 mnt
	cp -f irc ./mnt/irc
	umount mnt
	rmdir mnt

iso: irc
	cp irc ../../iso/

clean:
	rm -f *.o irc irc_linux irc.img $(OBJS)
# implicit rules
.asm.o:
	$(NASM) -o$@ $<

.c.o:
	$(CC) -c -o$@ $<

#: dependencies
# boot
start.o:				start.asm			$(MAKEDEP)
# kernel
main.o:					main.c				$(MAKEDEP)
net.o:					net.c				$(MAKEDEP)
proto.o:				proto.c				$(MAKEDEP)
commands.o:				commands.c			$(MAKEDEP)

# explicit rules
irc: $(OBJS) $(LIBC) $(MAKEDEP)
	$(LD) $(LFLAGS) -o$@ $(OBJS) $(LIBC)